## vastnfs-4.0.37.tar.xz

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0

# Retpoline support: check if this is the right architecture and that
# the kernel does not support it already.
# Alternatively, if we are called from the main mlnx-ofa build system,
# CONFIG_RETPOLINE will be set by the configure script, however
# subdir-ccflags-y will be set by the toplevel Makefile.
ifneq (,$(findstring $(ARCH),i386 x86_64))
  ifndef CONFIG_RETPOLINE
    ifneq (,$(shell awk 'BEGIN {if ($(VERSION).$(PATCHLEVEL) < 4.15) {print 1}}' </dev/null))
      CFLAGS_RETPOLINE=-mindirect-branch=thunk-inline -mindirect-branch-register -DRETPOLINE_MLNX
    endif
  endif
endif

# Enable retpoline support if the above holds and the compiler supports it.
ifneq (,$(CFLAGS_RETPOLINE))
  do_retpoline = $(call cc-option-yn, -mindirect-branch-register)
  subdir-ccflags-$(do_retpoline) += $(CFLAGS_RETPOLINE)
endif

obj-$(CONFIG_NVSTUB) = nvstub/
obj-y = bundle/

=== bundle/Makefile ===

obj-y                           += net/ fs/

=== inbox-compare/Makefile ===
obj-m = test.o

=== nvstub/Makefile ===
obj-m += nvstub.o

=== bundle/fs/Makefile ===

obj-$(CONFIG_NFS_FS)            += nfs/
obj-$(CONFIG_NFSD)              += nfsd/
obj-$(CONFIG_NFS_ACL_SUPPORT)   += nfs_common/
obj-$(CONFIG_LOCKD)             += lockd/

=== bundle/net/Makefile ===

obj-$(CONFIG_SUNRPC)            += sunrpc/

=== bundle/fs/lockd/Makefile ===
# SPDX-License-Identifier: GPL-2.0
#
# Makefile for the linux lock manager stuff
#

obj-$(CONFIG_LOCKD) += lockd.o

lockd-objs-y := clntlock.o clntproc.o clntxdr.o host.o svc.o svclock.o \
	        svcshare.o svcproc.o svcsubs.o mon.o xdr.o
lockd-objs-$(CONFIG_LOCKD_V4) += clnt4xdr.o xdr4.o svc4proc.o
lockd-objs-$(CONFIG_PROC_FS) += procfs.o
lockd-objs		      := $(lockd-objs-y)

include $(src)/../../net/sunrpc/Makefile.lib
$(eval $(call XDR_TRACE_CLASS,NLM4,clnt4xdr.o,nlm4trace_classes.h,../../))
$(eval $(call XDR_TRACE_CLASS,NLM,clntxdr.o,nlmtrace_classes.h,../../))
$(eval $(call XDR_TRACE_CLASS,NSM,clntxdr.o,nsmtrace_classes.h,../../))

=== bundle/fs/nfs/Makefile ===
# SPDX-License-Identifier: GPL-2.0
#
# Makefile for the Linux nfs filesystem routines.
#

obj-$(CONFIG_NFS_FS) += nfs.o

CFLAGS_nfstrace.o += -I$(src)
CFLAGS_nfsxdrtrace.o += -I$(src)
nfs-y 			:= client.o dir.o file.o getroot.o inode.o super.o \
			   io.o direct.o pagelist.o read.o symlink.o unlink.o \
			   write.o namespace.o mount_clnt.o nfstrace.o \
			   export.o sysfs.o fs_context.o debugfs.o
nfs-$(CONFIG_ROOT_NFS)	+= nfsroot.o
nfs-$(CONFIG_SYSCTL)	+= sysctl.o
nfs-$(CONFIG_NFS_FSCACHE) += fscache.o fscache-index.o

obj-$(CONFIG_NFS_V2) += nfsv2.o
nfsv2-y := nfs2super.o proc.o nfs2xdr.o

obj-$(CONFIG_NFS_V3) += nfsv3.o
nfsv3-y := nfs3super.o nfs3client.o nfs3proc.o nfs3xdr.o
nfsv3-$(CONFIG_NFS_V3_ACL) += nfs3acl.o

obj-$(CONFIG_NFS_V4) += nfsv4.o
CFLAGS_nfs4trace.o += -I$(src)
CFLAGS_nfs4xdrtrace.o += -I$(src)
nfsv4-y := nfs4proc.o nfs4xdr.o nfs4state.o nfs4renewd.o nfs4super.o nfs4file.o \
	  delegation.o nfs4idmap.o callback.o callback_xdr.o callback_proc.o \
	  nfs4namespace.o nfs4getroot.o nfs4client.o nfs4session.o \
	  dns_resolve.o nfs4trace.o
nfsv4-$(CONFIG_NFS_USE_LEGACY_DNS) += cache_lib.o
nfsv4-$(CONFIG_SYSCTL)	+= nfs4sysctl.o
nfsv4-$(CONFIG_NFS_V4_1)	+= pnfs.o pnfs_dev.o pnfs_nfs.o
nfsv4-$(CONFIG_NFS_V4_2)	+= nfs42proc.o nfs42xattr.o

obj-$(CONFIG_PNFS_FILE_LAYOUT) += filelayout/
obj-$(CONFIG_PNFS_BLOCK) += blocklayout/
obj-$(CONFIG_PNFS_FLEXFILE_LAYOUT) += flexfilelayout/

include $(src)/../../net/sunrpc/Makefile.lib

$(eval $(call XDR_TRACE_CLASS,NFS4,nfs4xdr.o,nfs4trace_classes.h,../../))
$(eval $(call XDR_TRACE_CLASS,NFS3,nfs3xdr.o,nfs3trace_classes.h,../../))
$(obj)/mount_clnt.o: $(obj)/nfs3trace_classes.h

=== bundle/fs/nfs_common/Makefile ===
obj-$(CONFIG_NFS_ACL_SUPPORT) += nfs_acl.o
nfs_acl-objs := nfsacl.o

# Because nfs_ssc may be builtin in the target kernel, it is better to have
# a separate name for it.
obj-$(CONFIG_NFS_V4_2_SSC_HELPER) += compat_nfs_ssc.o
compat_nfs_ssc-objs := nfs_ssc.o

=== bundle/fs/nfsd/Makefile ===
# SPDX-License-Identifier: GPL-2.0
#
# Makefile for the Linux nfs server
#

ccflags-y += -I$(src)			# needed for trace events

obj-$(CONFIG_NFSD)	+= nfsd.o

ifeq ($(COMPAT_DETECT_IDR_GET_NEXT_UL)$(COMPAT_DETECT_IOV_ITER_DISCARD),yy)
# this one should be compiled first, as the tracing macros can easily blow up
nfsd-y			+= trace.o

nfsd-y 			+= nfssvc.o nfsctl.o nfsproc.o nfsfh.o vfs.o \
			   export.o auth.o lockd.o nfscache.o nfsxdr.o \
			   stats.o filecache.o
nfsd-$(CONFIG_NFSD_V2_ACL) += nfs2acl.o
nfsd-$(CONFIG_NFSD_V3)	+= nfs3proc.o nfs3xdr.o
nfsd-$(CONFIG_NFSD_V3_ACL) += nfs3acl.o
nfsd-$(CONFIG_NFSD_V4)	+= nfs4proc.o nfs4xdr.o nfs4state.o nfs4idmap.o \
			   nfs4acl.o nfs4callback.o nfs4recover.o
nfsd-$(CONFIG_NFSD_PNFS) += nfs4layouts.o
nfsd-$(CONFIG_NFSD_BLOCKLAYOUT) += blocklayout.o blocklayoutxdr.o
nfsd-$(CONFIG_NFSD_SCSILAYOUT) += blocklayout.o blocklayoutxdr.o
nfsd-$(CONFIG_NFSD_FLEXFILELAYOUT) += flexfilelayout.o flexfilelayoutxdr.o
nfsd-$(CONFIG_NFSD_NEW_FAULT_INJECTION) += fault_inject.o

else
nfsd-y += stub.o
endif

=== bundle/net/sunrpc/Makefile ===
# SPDX-License-Identifier: GPL-2.0
#
# Makefile for Linux kernel SUN RPC
#


obj-$(CONFIG_SUNRPC) += sunrpc.o
obj-$(CONFIG_SUNRPC_GSS) += auth_gss/

ifeq ($(CONFIG_SUNRPC_XPRT_RDMA),m)
obj-m += xprtrdma/
else
obj-m += rpcrdma.o
rpcrdma-y := rpcrdma_dummy.o
endif

sunrpc-y := clnt.o xprt.o socklib.o xprtsock.o sched.o \
	    auth.o auth_null.o auth_unix.o \
	    svc.o svcsock.o svcauth.o svcauth_unix.o \
	    addr.o addr_external.o rpcb_clnt.o timer.o xdr.o \
	    sunrpc_syms.o cache.o rpc_pipe.o sysfs.o \
	    svc_xprt.o \
	    xprtmultipath.o
sunrpc-$(CONFIG_SUNRPC_DEBUG) += debugfs.o
sunrpc-$(CONFIG_SUNRPC_BACKCHANNEL) += backchannel_rqst.o
sunrpc-$(CONFIG_PROC_FS) += stats.o
sunrpc-$(CONFIG_SYSCTL) += sysctl.o

include $(src)/../../net/sunrpc/Makefile.lib
$(eval $(call XDR_TRACE_CLASS,RPCB,rpcb_clnt.o,rpcb_trace_classes.h,../../))

sunrpc-y += compat.o

=== bundle/net/sunrpc/xprtrdma/Makefile ===
# SPDX-License-Identifier: GPL-2.0
obj-$(CONFIG_SUNRPC_XPRT_RDMA) += rpcrdma.o

rpcrdma-y := transport.o rpc_rdma.o verbs.o frwr_ops.o \
	svc_rdma.o svc_rdma_backchannel.o svc_rdma_transport.o \
	svc_rdma_sendto.o svc_rdma_recvfrom.o svc_rdma_rw.o \
	svc_rdma_pcl.o module.o nvfs_rpc_rdma.o debugfs.o
rpcrdma-$(CONFIG_SUNRPC_BACKCHANNEL) += backchannel.o

=== debian/changelog ===
vastnfs (4.5-OFED.4.5.1.0.1.1.gb4fdfac.multikernel.vastdata) unstable; urgency=low

  * Initial release.

 -- Alaa Hleihel <alaa@mellanox.com>  Mon, 15 Aug 2016 13:30:53 +0200

=== src/v3.9.30.for.3.10.0-693.21.1.centos/debian/changelog ===
mlnx-nfsrdma (4.5-OFED.4.5.1.0.1.1.gb4fdfac.multikernel.vastdata) unstable; urgency=low

  * Initial release.

 -- Alaa Hleihel <alaa@mellanox.com>  Mon, 15 Aug 2016 13:30:53 +0200

=== debian/control ===
Source: vastnfs
Section: kernel
Priority: optional
Maintainer: Mellanox Technologies <support@mellanox.com>
Build-Depends: debhelper (>= 8.0.0), autotools-dev, bzip2, dkms
Standards-Version: 1.0
Homepage: http://www.mellanox.com

Package: vastnfs-dkms
Section: kernel
Architecture: all
Depends: dkms, make ${extra-package-deps}, ${misc:Depends}
Recommends: linux-headers-arm64 | linux-headers-powerpc | linux-headers-ppc64 | linux-headers-ppc64le | linux-headers-amd64 | linux-headers | linux-headers-generic
Description: DKMS support for NFS RDMA kernel module
 This package provides integration with the DKMS infrastructure for automatically building out of tree kernel modules.
 .
 This package contains the source to be built with dkms.

=== src/v3.9.30.for.3.10.0-693.21.1.centos/debian/control ===
Source: mlnx-nfsrdma
Section: kernel
Priority: optional
Maintainer: Mellanox Technologies <support@mellanox.com>
Build-Depends: debhelper (>= 8.0.0), autotools-dev, bzip2, dkms
Standards-Version: 1.0
Homepage: http://www.mellanox.com

Package: mlnx-nfsrdma-dkms
Section: kernel
Architecture: all
Depends: dkms, make ${extra-package-deps}, ${misc:Depends}
Recommends: linux-headers-arm64 | linux-headers-powerpc | linux-headers-ppc64 | linux-headers-ppc64le | linux-headers-amd64 | linux-headers | linux-headers-generic
Description: DKMS support for NFS RDMA kernel module
 This package provides integration with the DKMS infrastructure for automatically building out of tree kernel modules.
 .
 This package contains the source to be built with dkms.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# This version is for a hypothetical package that can build a kernel modules
# architecture-dependant package via make-kpkg, as well as an
# architecture-independent module source package, and other packages
# either dep/indep for things like common files or userspace components
# needed for the kernel modules.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

WITH_DKMS ?= 1
WITH_OFED ?= 1
MLXNUMC = $(shell grep ^processor /proc/cpuinfo | wc -l)
NJOBS ?= $(shell if [ $(MLXNUMC) -lt 16 ]; then echo $(MLXNUMC); else echo 16; fi)

pname:=vastnfs
psource:=$(pname)-source
ifeq ($(WITH_DKMS),1)
pdkms:=$(pname)-dkms
else
pdkms:=$(pname)-modules
endif
ifeq ($(WITH_OFED),1)
ifeq ($(WITH_DKMS),1)
extra_package_deps:=,mlnx-ofed-kernel-dkms
else
extra_package_deps:=,mlnx-ofed-kernel-modules
endif
ofaparam:=
else
extra_package_deps:=
ofaparam:=OFA_DIR=
endif

pversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')
dir_pversion := $(shell echo 99.${pversion} | tr : -)
prel := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-\(.\+\)/\2/p')

export INSTALL_MOD_DIR:=updates
export INSTALL_MOD_PATH:=$(CURDIR)/debian/$(pdkms)

DIST_NAME := $(shell lsb_release -si)
DIST_RELEASE := $(DIST_NAME)/$(shell lsb_release -sc)


KVER ?= $(shell uname -r)
KVER1 = $(shell echo $(KVER) | sed -e 's/_/-/g')
K_BUILD ?= "/lib/modules/$(KVER)/build"

%:
ifeq ($(WITH_DKMS),1)
	dh $@ --with dkms
else
	dh $@
endif

override_dh_auto_clean:

override_dh_auto_configure:

override_dh_auto_build:
ifneq ($(WITH_DKMS),1)
	@echo Building for $(KVER)
	make clean || true
	make $(ofaparam) -j$(NJOBS) KVER=$(KVER) K_BUILD=$(K_BUILD)
endif

override_dh_auto_test:

override_dh_auto_install:
	make build-info.txt
ifneq ($(WITH_DKMS),1)
	mkdir -p $(INSTALL_MOD_PATH)/etc/depmod.d
	cp $(CURDIR)/debian/depmod.conf $(INSTALL_MOD_PATH)/etc/depmod.d/nfsrdma.conf
	make install $(ofaparam) INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH) KERNELRELEASE=$(KVER) KVER=$(KVER) K_BUILD=$(K_BUILD)
	find $(INSTALL_MOD_PATH) \( -type f -a -name "modules.*" \) -delete
endif
	# For dkms
ifeq ($(WITH_DKMS),1)
	dh_installdirs -p$(pdkms)  usr/src/$(pname)-$(dir_pversion)
	cp -a ofa-patches inbox-compare compare-debuginfo.sh debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp makefile debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp Makefile debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp dkms.conf debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp build-info.h debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp -a bundle debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp ofa-filter.sh debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp _dkms-run.sh debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp -a compat debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)

	# Force DKMS to install our modules.
	# This is mostly needed for modules that do not have a version number info, as DKMS
	# will compare their srcversion field, which does not really say which module is newer.
	dh_installdirs -p$(pdkms)  usr/share/dkms/modules_to_force_install/
	echo "$(pname)" > debian/$(pdkms)/usr/share/dkms/modules_to_force_install/$(pname).force
endif
	mkdir -p debian/$(pdkms)/usr/share/vastnfs/
	cp build-info.txt debian/$(pdkms)/usr/share/vastnfs/
	mkdir -p debian/$(pdkms)/usr/bin
	cp scripts/vastnfs-ctl debian/$(pdkms)/usr/bin

override_dh_installinit:


ifneq ($(WITH_DKMS),1)
override_dh_gencontrol:
	dh_gencontrol -- -v$(pversion)-$(prel).kver.$(KVER1) -Vextra-package-deps=$(extra_package_deps)
else
override_dh_gencontrol:
	dh_gencontrol -- -Vextra-package-deps=$(extra_package_deps)
endif

ifneq ($(MLNX_KO_NO_STRIP),1)
ifneq ($(WITH_DKMS),1)
override_dh_strip:
	dh_strip
	find debian | grep -qE '[.]ko[.](zst|xz|gz)$$' || (find debian -name '*.ko' | xargs strip -g)
ifneq ($(MODULE_SIGN_PRIV_KEY),)
	./tools/sign-modules $(INSTALL_MOD_PATH) $(K_BUILD)
endif
endif
endif

=== src/v3.9.30.for.3.10.0-693.21.1.centos/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# This version is for a hypothetical package that can build a kernel modules
# architecture-dependant package via make-kpkg, as well as an
# architecture-independent module source package, and other packages
# either dep/indep for things like common files or userspace components
# needed for the kernel modules.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

WITH_DKMS ?= 1
WITH_OFED ?= 1
MLXNUMC = $(shell grep ^processor /proc/cpuinfo | wc -l)
NJOBS ?= $(shell if [ $(MLXNUMC) -lt 16 ]; then echo $(MLXNUMC); else echo 16; fi)

pname:=mlnx-nfsrdma
psource:=$(pname)-source
ifeq ($(WITH_DKMS),1)
pdkms:=$(pname)-dkms
else
pdkms:=$(pname)-modules
endif
ifeq ($(WITH_OFED),1)
ifeq ($(WITH_DKMS),1)
extra_package_deps:=,mlnx-ofed-kernel-dkms
else
extra_package_deps:=,mlnx-ofed-kernel-modules
endif
ofaparam:=
else
extra_package_deps:=
ofaparam:=OFA_DIR=
endif

pversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')
dir_pversion := $(shell echo 99.${pversion} | tr : -)
prel := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-\(.\+\)/\2/p')

export INSTALL_MOD_DIR:=updates
export INSTALL_MOD_PATH:=$(CURDIR)/debian/$(pdkms)

DIST_NAME := $(shell lsb_release -si)
DIST_RELEASE := $(DIST_NAME)/$(shell lsb_release -sc)


KVER ?= $(shell uname -r)
KVER1 = $(shell echo $(KVER) | sed -e 's/_/-/g')
K_BUILD ?= "/lib/modules/$(KVER)/build"

%:
ifeq ($(WITH_DKMS),1)
	dh $@ --with dkms
else
	dh $@
endif

override_dh_auto_clean:

override_dh_auto_configure:

override_dh_auto_build:
ifneq ($(WITH_DKMS),1)
	@echo Building for $(KVER)
	make clean || true
	make $(ofaparam) -j$(NJOBS) KVER=$(KVER) K_BUILD=$(K_BUILD)
endif

override_dh_auto_test:

override_dh_auto_install:
	make build-info.txt
ifneq ($(WITH_DKMS),1)
	mkdir -p $(INSTALL_MOD_PATH)/etc/depmod.d
	cp $(CURDIR)/debian/depmod.conf $(INSTALL_MOD_PATH)/etc/depmod.d/nfsrdma.conf
	make install $(ofaparam) INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH) KERNELRELEASE=$(KVER) KVER=$(KVER) K_BUILD=$(K_BUILD)
	find $(INSTALL_MOD_PATH) \( -type f -a -name "modules.*" \) -delete
endif
	# For dkms
ifeq ($(WITH_DKMS),1)
	dh_installdirs -p$(pdkms)  usr/src/$(pname)-$(dir_pversion)
	cp -a ofa-patches inbox-compare compare-debuginfo.sh debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp makefile debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp Makefile debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp dkms.conf debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp build-info.h debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp -a bundle debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp ofa-filter.sh debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp _dkms-run.sh debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)

	# Force DKMS to install our modules.
	# This is mostly needed for modules that do not have a version number info, as DKMS
	# will compare their srcversion field, which does not really say which module is newer.
	dh_installdirs -p$(pdkms)  usr/share/dkms/modules_to_force_install/
	echo "$(pname)" > debian/$(pdkms)/usr/share/dkms/modules_to_force_install/$(pname).force
endif
	mkdir -p debian/$(pdkms)/usr/share/mlnx-nfsrdma/
	cp build-info.txt debian/$(pdkms)/usr/share/mlnx-nfsrdma/

override_dh_installinit:


ifneq ($(WITH_DKMS),1)
override_dh_gencontrol:
	dh_gencontrol -- -v$(pversion)-$(prel).kver.$(KVER1) -Vextra-package-deps=$(extra_package_deps)
else
override_dh_gencontrol:
	dh_gencontrol -- -Vextra-package-deps=$(extra_package_deps)
endif

ifneq ($(MLNX_KO_NO_STRIP),1)
ifneq ($(WITH_DKMS),1)
override_dh_strip:
	dh_strip
	find debian -name '*.ko' | xargs strip -g
endif
endif

=== src/v3.9.30.for.4.4.140-96.80.sles/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# This version is for a hypothetical package that can build a kernel modules
# architecture-dependant package via make-kpkg, as well as an
# architecture-independent module source package, and other packages
# either dep/indep for things like common files or userspace components
# needed for the kernel modules.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

WITH_DKMS ?= 1
WITH_OFED ?= 1
MLXNUMC = $(shell grep ^processor /proc/cpuinfo | wc -l)
NJOBS ?= $(shell if [ $(MLXNUMC) -lt 16 ]; then echo $(MLXNUMC); else echo 16; fi)

pname:=mlnx-nfsrdma
psource:=$(pname)-source
ifeq ($(WITH_DKMS),1)
pdkms:=$(pname)-dkms
else
pdkms:=$(pname)-modules
endif
ifeq ($(WITH_OFED),1)
ifeq ($(WITH_DKMS),1)
extra_package_deps:=,mlnx-ofed-kernel-dkms
else
extra_package_deps:=,mlnx-ofed-kernel-modules
endif
ofaparam:=
else
extra_package_deps:=
ofaparam:=OFA_DIR=
endif

pversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')
dir_pversion := $(shell echo 99.${pversion} | tr : -)
prel := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-\(.\+\)/\2/p')

export INSTALL_MOD_DIR:=updates
export INSTALL_MOD_PATH:=$(CURDIR)/debian/$(pdkms)

DIST_NAME := $(shell lsb_release -si)
DIST_RELEASE := $(DIST_NAME)/$(shell lsb_release -sc)


KVER ?= $(shell uname -r)
KVER1 = $(shell echo $(KVER) | sed -e 's/_/-/g')
K_BUILD ?= "/lib/modules/$(KVER)/build"

%:
ifeq ($(WITH_DKMS),1)
	dh $@ --with dkms
else
	dh $@
endif

override_dh_auto_clean:

override_dh_auto_configure:

override_dh_auto_build:
ifneq ($(WITH_DKMS),1)
	@echo Building for $(KVER)
	make clean || true
	make $(ofaparam) -j$(NJOBS) KVER=$(KVER) K_BUILD=$(K_BUILD)
endif

override_dh_auto_test:

override_dh_auto_install:
	make build-info.txt
ifneq ($(WITH_DKMS),1)
	mkdir -p $(INSTALL_MOD_PATH)/etc/depmod.d
	cp $(CURDIR)/debian/depmod.conf $(INSTALL_MOD_PATH)/etc/depmod.d/nfsrdma.conf
	make install $(ofaparam) INSTALL_MOD_DIR=$(INSTALL_MOD_DIR) INSTALL_MOD_PATH=$(INSTALL_MOD_PATH) KERNELRELEASE=$(KVER) KVER=$(KVER) K_BUILD=$(K_BUILD)
	find $(INSTALL_MOD_PATH) \( -type f -a -name "modules.*" \) -delete
endif
	# For dkms
ifeq ($(WITH_DKMS),1)
	dh_installdirs -p$(pdkms)  usr/src/$(pname)-$(dir_pversion)
	cp -a inbox-compare compare-debuginfo.sh debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp makefile debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp Makefile debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp dkms.conf debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp build-info.h debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp -a bundle debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp ofa-filter.sh debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)
	cp _dkms-run.sh debian/$(pdkms)/usr/src/$(pname)-$(dir_pversion)

	# Force DKMS to install our modules.
	# This is mostly needed for modules that do not have a version number info, as DKMS
	# will compare their srcversion field, which does not really say which module is newer.
	dh_installdirs -p$(pdkms)  usr/share/dkms/modules_to_force_install/
	echo "$(pname)" > debian/$(pdkms)/usr/share/dkms/modules_to_force_install/$(pname).force
endif
	mkdir -p debian/$(pdkms)/usr/share/mlnx-nfsrdma/
	cp build-info.txt debian/$(pdkms)/usr/share/mlnx-nfsrdma/

override_dh_installinit:


ifneq ($(WITH_DKMS),1)
override_dh_gencontrol:
	dh_gencontrol -- -v$(pversion)-$(prel).kver.$(KVER1) -Vextra-package-deps=$(extra_package_deps)
else
override_dh_gencontrol:
	dh_gencontrol -- -Vextra-package-deps=$(extra_package_deps)
endif

ifneq ($(MLNX_KO_NO_STRIP),1)
ifneq ($(WITH_DKMS),1)
override_dh_strip:
	dh_strip
	find debian -name '*.ko' | xargs strip -g
endif
endif
